Index: /java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 96)
@@ -14,9 +14,7 @@
 import com.framsticks.util.FramsticksException;
 
-
-
 public abstract class AbstractJoinable implements Joinable {
+
 	private static final Logger log = Logger.getLogger(AbstractJoinable.class);
-
 
 	protected final Set<JoinableParent> owners = new HashSet<JoinableParent>();
@@ -25,5 +23,7 @@
 	protected static final Set<AbstractJoinable> joinablesRegistry = Collections.synchronizedSet(new HashSet<AbstractJoinable>());
 
-	JoinableState state = JoinableState.INITILIAZED;
+	protected JoinableState state = JoinableState.INITILIAZED;
+	protected JoinableParent parent;
+	protected Monitor monitor;
 
 	/**
@@ -53,17 +53,16 @@
 		this.state = state;
 
-		synchronized (this) {
-			log.debug(this + " is notifying " + joinableListeners.size() + " parents");
-
-			List<JoinableParent> parents = new LinkedList<>();
-			CollectionUtils.addAll(parents, joinableListeners.iterator());
-
-			for (JoinableParent p : parents) {
-				if (p != null) {
-					Dispatching.childChangedState(p, this, state);
-				}
-			}
-			this.notifyAll();
-		}
+		log.debug(this + " is notifying " + joinableListeners.size() + " parents");
+
+		List<JoinableParent> parents = new LinkedList<>();
+		CollectionUtils.addAll(parents, joinableListeners.iterator());
+
+		for (JoinableParent p : parents) {
+			if (p != null) {
+				Dispatching.childChangedState(p, this, state);
+			}
+		}
+		this.notifyAll();
+
 		report();
 
@@ -145,4 +144,6 @@
 		}
 		if (start) {
+			assert monitor == null;
+			monitor = owner.getMonitor();
 			return this.start();
 		}
@@ -185,4 +186,18 @@
 	}
 
+	protected boolean isRunning() {
+		return state.equals(JoinableState.RUNNING);
+	}
+
+	@Override
+	public String toString() {
+		return getName();
+	}
+
+	// @Override
+	public Monitor getMonitor() {
+		return monitor;
+	}
+
 
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 96)
@@ -3,4 +3,5 @@
 import org.apache.log4j.Logger;
 
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.StateFunctor;
 
@@ -28,5 +29,5 @@
 			@Override
 			public void run() {
-				stateFunctor.call(null);
+				stateFunctor.call();
 			}
 		});
@@ -170,5 +171,47 @@
 	}
 
-
+	public static class Waiter {
+		protected boolean done = false;
+
+		protected final double timeOut;
+
+		/**
+		 * @param timeOut
+		 */
+		public Waiter(double timeOut) {
+			this.timeOut = timeOut;
+		}
+
+		public synchronized void pass() {
+			done = true;
+			this.notify();
+		}
+
+		public synchronized void waitFor() {
+			long end = System.currentTimeMillis() + (int)(timeOut * 1000);
+			while ((!done) && System.currentTimeMillis() < end) {
+				try {
+					this.wait(end - System.currentTimeMillis());
+				} catch (InterruptedException e) {
+					break;
+				}
+			}
+			if (!done) {
+				throw new FramsticksException().msg("waiter timed out");
+			}
+		}
+	}
+
+
+	public static <C> void synchronize(Dispatcher<C> dispatcher, double seconds) {
+		final Waiter waiter = new Waiter(seconds);
+		dispatcher.dispatch(new RunAt<C>() {
+			@Override
+			public void run() {
+				waiter.pass();
+			}
+		});
+		waiter.waitFor();
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/ExceptionHandler.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/ExceptionHandler.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/ExceptionHandler.java	(revision 96)
@@ -0,0 +1,6 @@
+package com.framsticks.util.dispatching;
+
+public interface ExceptionHandler {
+	public boolean handle(Dispatcher<?> dispatcher, Throwable throwable);
+
+}
Index: /java/main/src/main/java/com/framsticks/util/dispatching/ExceptionResultHandler.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/ExceptionResultHandler.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/ExceptionResultHandler.java	(revision 96)
@@ -0,0 +1,7 @@
+package com.framsticks.util.dispatching;
+
+import com.framsticks.util.FramsticksException;
+
+public interface ExceptionResultHandler {
+	public void handle(FramsticksException exception);
+}
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Future.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 96)
@@ -1,8 +1,46 @@
 package com.framsticks.util.dispatching;
+
+import com.framsticks.util.FramsticksException;
 
 /**
  * @author Piotr Sniegowski
  */
-public interface Future <T> {
-    void result(T result, Exception e);
+public abstract class Future<T> implements ExceptionResultHandler {
+
+	protected final ExceptionResultHandler handler;
+
+	public Future(ExceptionResultHandler handler) {
+		this.handler = handler;
+	}
+
+	public Future() {
+		this.handler = null;
+	}
+
+	protected abstract void result(T result);
+
+	public final void pass(T result) {
+		try {
+			result(result);
+		} catch (FramsticksException e) {
+			handle(e);
+		}
+	}
+
+	public static <T> void passOrHandle(Future<T> future, T value, FramsticksException e) {
+		if (e != null) {
+			future.handle(e);
+		} else {
+			future.pass(value);
+		}
+	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		if (handler != null) {
+			handler.handle(exception);
+			return;
+		}
+		throw exception;
+	}
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Joinable.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Joinable.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Joinable.java	(revision 96)
@@ -5,4 +5,11 @@
 
 public interface Joinable {
+
+	/** The name of the joinable.
+	 *
+	 * It should never be empty, but it is not required to remain
+	 * constant during lifetime of the object.
+	 */
+	public String getName();
 
 	public boolean use(@Nonnull JoinableParent owner);
Index: /java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 96)
@@ -2,11 +2,8 @@
 
 import java.util.Collections;
-import java.util.HashMap;
 import java.util.HashSet;
 import java.util.Iterator;
-import java.util.Map;
 import java.util.Set;
 
-import com.framsticks.core.Entity;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -19,5 +16,4 @@
 
 	protected final Set<T> joinables = new HashSet<T>();
-	protected final Map<String, T> namedJoinables = new HashMap<>();
 
 	protected boolean finishIfOne;
@@ -34,22 +30,17 @@
 
 	@AutoAppendAnnotation
-	public void add(T joinable) {
-		assert isInState(JoinableState.INITILIAZED);
+	public synchronized void add(T joinable) {
+		if (this.state.ordinal() > JoinableState.RUNNING.ordinal()) {
+			throw new FramsticksException().msg("failed to add joinable - collection is passed running state").arg("joinable", joinable).arg("collection", this);
+		}
 
 		if (joinables.contains(joinable)) {
 			throw new FramsticksException().msg("joinable is already observed").arg("joinable", joinable).arg("in", this);
 		}
-		// if (observables.containsKey(observable.getName())) {
-		// 	throw new FramsticksException().msg("observable with given name already exists").arg("name", observable.getName()).arg("in", this);
-		// }
+		joinables.add(joinable);
 
-		if (joinable instanceof Entity) {
-			Entity e = (Entity) joinable;
-			if (!namedJoinables.containsKey(e.getName())) {
-				namedJoinables.put(e.getName(), joinable);
-			}
+		if (this.state.equals(JoinableState.RUNNING)) {
+			Dispatching.use(joinable, this);
 		}
-
-		joinables.add(joinable);
 	}
 
@@ -107,5 +98,4 @@
 	public void childChangedState(Joinable joinable, JoinableState state) {
 		proceedToState(getNextState());
-
 	}
 
@@ -129,10 +119,23 @@
 
 	public T get(String name) {
-		return namedJoinables.get(name);
+		for (T j : joinables) {
+			if (j.getName().equals(name)) {
+				return j;
+			}
+		}
+		return null;
 	}
 
+	public int size() {
+		return joinables.size();
+	}
 
-	public Map<String, T> getObservables() {
-		return Collections.unmodifiableMap(namedJoinables);
+	public boolean contains(T joinable) {
+		return joinables.contains(joinable);
+	}
+
+	@Override
+	public String getName() {
+		return observableName;
 	}
 
Index: /java/main/src/main/java/com/framsticks/util/dispatching/JoinableParent.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/JoinableParent.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/JoinableParent.java	(revision 96)
@@ -4,4 +4,5 @@
 
 	public void childChangedState(Joinable joinable, JoinableState state);
+	public Monitor getMonitor();
 
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 96)
@@ -2,6 +2,6 @@
 
 import org.apache.log4j.Logger;
-// import edu.umd.cs.findbugs.annotations.SuppressWarnings;
 import com.framsticks.util.dispatching.Dispatching;
+import java.lang.Thread;
 
 public class Monitor implements JoinableParent {
@@ -10,4 +10,5 @@
 
 	protected final Joinable joinable;
+	protected final Thread shutdownHook;
 
 	/**
@@ -16,4 +17,20 @@
 	public Monitor(Joinable joinable) {
 		this.joinable = joinable;
+
+		shutdownHook = new Thread(new Runnable() {
+			@Override
+			public void run() {
+				log.debug("running shutdown hook");
+				Monitor.this.drop().join();
+			}
+		});
+	}
+
+	public Monitor use() {
+		Runtime.getRuntime().addShutdownHook(shutdownHook);
+
+		log.debug(this + " is using");
+		Dispatching.use(joinable, this);
+		return this;
 	}
 
@@ -34,9 +51,4 @@
 	}
 
-	public Monitor use() {
-		log.debug(this + " is using");
-		Dispatching.use(joinable, this);
-		return this;
-	}
 
 	public Monitor drop() {
@@ -50,4 +62,11 @@
 		Dispatching.joinAbsolutely(joinable);
 		log.debug(this + " is joined");
+
+		try {
+			Runtime.getRuntime().removeShutdownHook(shutdownHook);
+		} catch (IllegalStateException e) {
+			/** In case IllegalStateException is caught, it means that JVM is in finalization stage */
+		}
+
 		return this;
 	}
@@ -67,3 +86,24 @@
 	}
 
+	@Override
+	public Monitor getMonitor() {
+		return this;
+	}
+
+	protected ExceptionHandler taskExceptionHandler;
+
+	/**
+	 * @return the taskExceptionHandler
+	 */
+	public ExceptionHandler getTaskExceptionHandler() {
+		return taskExceptionHandler;
+	}
+
+	/**
+	 * @param taskExceptionHandler the taskExceptionHandler to set
+	 */
+	public void setTaskExceptionHandler(ExceptionHandler taskExceptionHandler) {
+		this.taskExceptionHandler = taskExceptionHandler;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Task.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 96)
@@ -13,5 +13,5 @@
 
 	public Task(long moment) {
-		this.moment = moment;
+		this.moment = System.currentTimeMillis() + moment;
 	}
 
Index: /java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 96)
@@ -47,4 +47,6 @@
 	protected void routine() {
 		log.debug("starting thread " + this);
+		assert getMonitor() != null;
+		ExceptionHandler exceptionHandler = getMonitor().getTaskExceptionHandler();
 		while (!java.lang.Thread.interrupted()) {
 			Task<? extends C> task;
@@ -73,4 +75,9 @@
 				task.run();
 			} catch (Exception e) {
+				if (exceptionHandler != null) {
+					if (exceptionHandler.handle(this, e)) {
+						continue;
+					}
+				}
 				log.error("error in thread: ", e);
 			}
Index: /java/main/src/main/java/com/framsticks/util/dispatching/WrappedFuture.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/dispatching/WrappedFuture.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/util/dispatching/WrappedFuture.java	(revision 96)
@@ -0,0 +1,30 @@
+package com.framsticks.util.dispatching;
+
+public abstract class WrappedFuture<T> extends Future<T> {
+
+	public abstract T process(T result);
+
+	protected Future<T> future;
+
+	public WrappedFuture(Future<T> future) {
+		super(future);
+		this.future = future;
+	}
+
+	@Override
+	protected void result(T result) {
+		T processed;
+		processed = process(result);
+		if (future != null) {
+			future.pass(processed);
+		}
+	}
+
+	public Future<T> move() {
+		assert future != null;
+		Future<T> result = future;
+		future = null;
+		return result;
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/util/lang/Delimeted.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Delimeted.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/lang/Delimeted.java	(revision 96)
@@ -3,7 +3,7 @@
 import java.util.Iterator;
 
-import org.apache.commons.collections.Closure;
+// import org.apache.commons.collections.Closure;
 
-public class Delimeted implements Closure {
+public class Delimeted<T> {
 
 	protected final String delimeter;
@@ -19,5 +19,5 @@
 	}
 
-	public final Delimeted append(Object object) {
+	public final Delimeted<T> append(T object) {
 		if (builder != null) {
 			builder.append(delimeter);
@@ -29,5 +29,5 @@
 	}
 
-	public final Delimeted append(Iterator<?> i) {
+	public final Delimeted<T> append(Iterator<T> i) {
 		while (i.hasNext()) {
 			append(i.next());
@@ -41,7 +41,12 @@
 
 	@Override
-	public void execute(Object input) {
-		append(input);
+	public String toString() {
+		return build();
 	}
 
+	// @Override
+	// public void execute(Object input) {
+	// 	append(input);
+	// }
+
 }
Index: /java/main/src/main/java/com/framsticks/util/lang/Holder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Holder.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/util/lang/Holder.java	(revision 96)
@@ -0,0 +1,35 @@
+package com.framsticks.util.lang;
+
+public class Holder<T> {
+
+	protected T value;
+
+
+	/**
+	 *
+	 */
+	public Holder() {
+	}
+
+	/**
+	 * @param value
+	 */
+	public Holder(T value) {
+		this.value = value;
+	}
+
+	/**
+	 * @return the value
+	 */
+	public T get() {
+		return value;
+	}
+
+	/**
+	 * @param value the value to set
+	 */
+	public void set(T value) {
+		this.value = value;
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/util/lang/Pair.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Pair.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/lang/Pair.java	(revision 96)
@@ -24,5 +24,4 @@
 		}
 		Pair<?, ?> p = (Pair<?, ?>) obj;
-		// return first == p.first && second.equals(se)
 		return first.equals(p.first) && second.equals(p.second);
 	}
@@ -33,3 +32,7 @@
 	}
 
+	public static <U1, U2> Pair<U1, U2> make(U1 first, U2 second) {
+		return new Pair<U1, U2>(first, second);
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/util/lang/Strings.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 96)
@@ -1,3 +1,5 @@
 package com.framsticks.util.lang;
+
+import com.framsticks.util.FramsticksException;
 
 /**
@@ -15,4 +17,10 @@
 	public static boolean notEmpty(String str) {
 		return str != null && !str.equals("");
+	}
+
+	public static void assureNotEmpty(String str) {
+		if (!notEmpty(str)) {
+			throw new FramsticksException().msg("string is empty");
+		}
 	}
 
@@ -35,9 +43,7 @@
 		int pos = string.indexOf(separator);
 		if (pos == -1) {
-			return new Pair<String, String>(string.substring(0,
-					string.length() - 1), second);
+			return new Pair<String, String>(string, second);
 		} else {
-			return new Pair<String, String>(string.substring(0, pos),
-					string.substring(pos + 1));
+			return new Pair<String, String>(string.substring(0, pos), string.substring(pos + 1));
 		}
 	}
Index: /java/main/src/test/java/com/framsticks/communication/ConnectionTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/communication/ConnectionTest.java	(revision 96)
+++ /java/main/src/test/java/com/framsticks/communication/ConnectionTest.java	(revision 96)
@@ -0,0 +1,15 @@
+package com.framsticks.communication;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.test.TestConfiguration;
+
+@Test
+public class ConnectionTest extends TestConfiguration {
+
+	@Test
+	public void patterns() {
+	}
+
+
+}
Index: /java/main/src/test/java/com/framsticks/communication/RequestTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/communication/RequestTest.java	(revision 96)
+++ /java/main/src/test/java/com/framsticks/communication/RequestTest.java	(revision 96)
@@ -0,0 +1,54 @@
+package com.framsticks.communication;
+
+import org.testng.annotations.DataProvider;
+import org.testng.annotations.Test;
+
+import com.framsticks.communication.queries.CallRequest;
+import com.framsticks.communication.queries.GetRequest;
+import com.framsticks.communication.queries.InfoRequest;
+import com.framsticks.communication.queries.SetRequest;
+import com.framsticks.communication.queries.UseRequest;
+import com.framsticks.communication.queries.VersionRequest;
+import com.framsticks.test.TestConfiguration;
+import com.framsticks.util.lang.Pair;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class RequestTest extends TestConfiguration {
+
+	@Test
+	public void genericParsing() {
+		assertThat(Request.takeIdentifier("first second")).isEqualTo(Pair.make("first", "second"));
+		assertThat(Request.takeIdentifier(" first ")).isEqualTo(Pair.make("first", ""));
+
+		assertThat(Request.takeString(" \"a long comment\" second")).isEqualTo(Pair.make("a long comment", "second"));
+		assertThat(Request.takeString(" simple second")).isEqualTo(Pair.make("simple", "second"));
+
+		assertThat(Request.takeRequestId(true, " 2 simple second")).isEqualTo(Pair.make(2, "simple second"));
+	}
+
+	@Test(dataProvider = "requests", dependsOnMethods = "genericParsing")
+	public void parsingAndPrintingRequests(Class<? extends Request> requestClass, String line) {
+		Pair<CharSequence, CharSequence> pair = Request.takeIdentifier(line);
+		Request request = Request.parse(pair.first, pair.second);
+		assertThat(request).isInstanceOf(requestClass);
+		assertThat(request.stringRepresentation()).isEqualTo(line);
+	}
+
+	@DataProvider
+	public Object[][] requests() {
+		return new Object[][] {
+			{ CallRequest.class, "call /object function first second \"thi rd\""},
+			{ GetRequest.class, "get /test"},
+			{ GetRequest.class, "get /test one_field"},
+			{ GetRequest.class, "get /test first_field,second_field"},
+			{ SetRequest.class, "set /test field value"},
+			{ SetRequest.class, "set /test field \"value with spaces\""},
+			{ VersionRequest.class, "version 4"},
+			{ InfoRequest.class, "info /some/path"},
+			{ UseRequest.class, "use request_id"}
+		};
+	}
+
+}
Index: /java/main/src/test/java/com/framsticks/core/FramsticksTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/core/FramsticksTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/core/FramsticksTest.java	(revision 96)
@@ -20,6 +20,6 @@
 		Framsticks framsticks = Framsticks.loadConfiguration(stream);
 		assertThat(framsticks).isNotNull();
-		assertThat(framsticks.getObservables().size()).isEqualTo(1);
-		assertThat(framsticks.getObservables().get("browser")).isInstanceOf(Browser.class);
+		assertThat(framsticks.size()).isEqualTo(1);
+		assertThat(framsticks.get("browser")).isInstanceOf(Browser.class);
 	}
 
Index: /java/main/src/test/java/com/framsticks/core/ObjectInstanceTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/core/ObjectInstanceTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/core/ObjectInstanceTest.java	(revision 96)
@@ -19,4 +19,7 @@
 import com.framsticks.params.ReflectionAccess;
 import com.framsticks.params.types.FloatParam;
+
+import static com.framsticks.core.InstanceUtils.*;
+
 
 import static org.fest.assertions.Assertions.*;
@@ -48,5 +51,5 @@
 	public void startInstance() {
 		instance = new ObjectInstance();
-		instance.getRegistry().takeAllFrom(schema.getRegistry());
+		instance.takeAllFrom(schema.getRegistry());
 
 		instance.setRootObject(model);
@@ -62,20 +65,20 @@
 			})).isEqualTo("bla");
 
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
 				assertThat(instance.getRootObject(Model.class).getNeuroDefinitions().get(2).details).isEqualTo("G");
 
-				Path path = instance.getPath("/");
+				Path path = Path.to(instance, "/");
 				assertThat(path.isResolved());
-				AccessInterface access = instance.bindAccess(path);
+				AccessInterface access = InstanceUtils.bindAccess(path);
 				assertThat(access.get("se", Double.class)).isEqualTo(1.0);
 
-				assertThat(instance.bindAccess("/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getDef(Double.class)).isEqualTo(1.0);
-				assertThat(instance.bindAccess("/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
-				assertThat(instance.bindAccess("/parts/2")).isInstanceOf(ReflectionAccess.class);
-				assertThat(instance.getPath("/neurodefs").getTopObject()).isInstanceOf(ArrayList.class);
-				assertThat(instance.getPath("/joints/1").getTopObject()).isInstanceOf(Joint.class);
-				assertThat(instance.bindAccess("/parts/2").get("i", String.class)).isEqualTo("bla");
+				assertThat(bindAccess(instance, "/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getDef(Double.class)).isEqualTo(1.0);
+				assertThat(bindAccess(instance, "/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
+				assertThat(bindAccess(instance, "/parts/2")).isInstanceOf(ReflectionAccess.class);
+				assertThat(Path.to(instance, "/neurodefs").getTopObject()).isInstanceOf(ArrayList.class);
+				assertThat(Path.to(instance, "/joints/1").getTopObject()).isInstanceOf(Joint.class);
+				assertThat(bindAccess(instance, "/parts/2").get("i", String.class)).isEqualTo("bla");
 			}
 		});
Index: /java/main/src/test/java/com/framsticks/core/XmlBasedTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/core/XmlBasedTest.java	(revision 96)
+++ /java/main/src/test/java/com/framsticks/core/XmlBasedTest.java	(revision 96)
@@ -0,0 +1,31 @@
+package com.framsticks.core;
+
+import java.io.InputStream;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.core.Framsticks;
+import com.framsticks.test.MonitorBasedTest;
+import com.framsticks.util.dispatching.Joinable;
+
+// import static org.fest.assertions.Assertions.*;
+
+@Test
+public abstract class XmlBasedTest extends MonitorBasedTest {
+
+	protected Framsticks framsticks;
+
+	@Override
+	protected Joinable createSubject() {
+		framsticks = Framsticks.loadConfiguration(getConfigurationStream());
+		return framsticks;
+	}
+
+	protected InputStream getConfigurationStream() {
+		return XmlBasedTest.class.getResourceAsStream("/configs/" + getConfigurationName());
+	}
+
+	protected abstract String getConfigurationName();
+
+
+}
Index: /java/main/src/test/java/com/framsticks/dumping/StreamTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/dumping/StreamTest.java	(revision 96)
+++ /java/main/src/test/java/com/framsticks/dumping/StreamTest.java	(revision 96)
@@ -0,0 +1,36 @@
+package com.framsticks.dumping;
+
+public class StreamTest {
+
+	public void testLoad() {
+
+		// dispatch(new RunAt<Instance>() {
+
+		// 	@Override
+		// 	public void run() {
+		// 		assert isActive();
+
+		// 		try {
+		// 			LoadStream stream = new LoadStream(FileInstance.this.getPath("/"), new BufferedReader(new InputStreamReader(new FileInputStream(file), Encoding.getFramsticksCharset())), FileInstance.this, new Future<Path>() {
+		// 				@Override
+		// 				public void result(Path result, Exception e) {
+		// 					if (e != null) {
+		// 						log.error("failed to load file instance " + FileInstance.this + ": " + e);
+		// 						fireRun(e);
+		// 						return;
+		// 					}
+		// 					log.info("loaded file instance " + FileInstance.this);
+		// 					fireRun(null);
+		// 				}
+		// 			});
+		// 			stream.load();
+		// 		} catch (IOException e) {
+		// 			log.error("io failure: " + e);
+		// 			fireRun(e);
+		// 		}
+		// 	}
+
+		// });
+	}
+
+}
Index: /java/main/src/test/java/com/framsticks/gui/BrowserBaseTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/gui/BrowserBaseTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/gui/BrowserBaseTest.java	(revision 96)
@@ -9,10 +9,8 @@
 import org.fest.swing.fixture.FrameFixture;
 import org.fest.swing.fixture.JTreeFixture;
-import org.testng.annotations.AfterClass;
-import org.testng.annotations.BeforeClass;
 import org.testng.annotations.Test;
 
-import com.framsticks.test.TestConfiguration;
-import com.framsticks.util.dispatching.Monitor;
+import com.framsticks.test.MonitorBasedTest;
+import com.framsticks.util.dispatching.Joinable;
 
 import static org.fest.assertions.Assertions.assertThat;
@@ -22,9 +20,8 @@
 
 @Test
-public abstract class BrowserBaseTest extends TestConfiguration {
+public abstract class BrowserBaseTest extends MonitorBasedTest {
 
 	private static final Logger log = Logger.getLogger(BrowserTest.class);
 
-	protected Monitor monitor;
 	protected Browser browser;
 	protected static Robot robot;
@@ -39,13 +36,11 @@
 	}
 
-	@BeforeClass(timeOut = 5000)
-	public void setUp() {
+	@Override
+	protected Joinable createSubject() {
+		configureBrowser();
+		return browser;
+	}
 
-		configureBrowser();
-
-		monitor = new Monitor(browser);
-
-		monitor.use();
-
+	protected void setUpAfterUse() {
 		frame = new FrameFixture(robot,
 				GuiActionRunner.execute(new GuiQuery<JFrame>() {
@@ -57,6 +52,8 @@
 
 		tree = frame.tree("tree");
+
 		log.debug("frame fixture done");
 	}
+
 
 	protected abstract void configureBrowser();
@@ -71,8 +68,3 @@
 	}
 
-	@AfterClass(timeOut = 5000)
-	public void tearDown() {
-		monitor.drop().join();
-	}
-
 }
Index: /java/main/src/test/java/com/framsticks/gui/BrowserTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 96)
@@ -10,5 +10,5 @@
 
 import com.framsticks.model.ModelPackage;
-import com.framsticks.remote.RemoteInstance;
+import com.framsticks.remote.SimulatorInstance;
 
 public class BrowserTest extends BrowserBaseTest {
@@ -16,5 +16,5 @@
 	private static final Logger log = Logger.getLogger(BrowserTest.class);
 
-	RemoteInstance localhost;
+	SimulatorInstance localhost;
 
 	@Override
@@ -22,5 +22,5 @@
 		browser = new Browser();
 
-		localhost = new RemoteInstance();
+		localhost = new SimulatorInstance();
 		localhost.setName("localhost");
 		localhost.setAddress("localhost:9009");
Index: /java/main/src/test/java/com/framsticks/gui/ObjectInstanceBrowserTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/gui/ObjectInstanceBrowserTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/gui/ObjectInstanceBrowserTest.java	(revision 96)
@@ -11,4 +11,6 @@
 import com.framsticks.parsers.XmlLoader;
 import com.framsticks.util.dispatching.RunAt;
+
+import static com.framsticks.core.InstanceUtils.*;
 
 @Test
@@ -29,5 +31,5 @@
 	@Test(timeOut = 10000)
 	public void testShow() {
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -40,8 +42,8 @@
 		clickAndExpandPath("model/parts/2");
 
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
-				assertThat(instance.bindAccess("/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
+				assertThat(bindAccess(instance, "/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
 			}
 		});
